Index: tests/regression/Fragmentation/ParseSaveFragmentResults/pre/create_results_dat.py
===================================================================
--- tests/regression/Fragmentation/ParseSaveFragmentResults/pre/create_results_dat.py	(revision 73a5f79e4f9ad7064ccf8574d08f5daf61ce8498)
+++ tests/regression/Fragmentation/ParseSaveFragmentResults/pre/create_results_dat.py	(revision 73a5f79e4f9ad7064ccf8574d08f5daf61ce8498)
@@ -0,0 +1,10 @@
+import pyMoleCuilder
+# ========================== Stored Session BEGIN ==========================
+pyMoleCuilder.MoleculeLoad("/home/heber/tmp/MoleCuilderTestingGrounds/Alkane/test.in")
+pyMoleCuilder.Undo()
+pyMoleCuilder.MoleculeLoad("/home/heber/tmp/MoleCuilderTestingGrounds/Alkane_LongRange_open/alkane-1.pdb")
+pyMoleCuilder.SelectionAllAtoms()
+pyMoleCuilder.GraphCorrectBondDegree()
+pyMoleCuilder.FragmentationFragmentation("BondFragment", "3", "2", "1", "1", "", "5", "0", "0", "0")
+pyMoleCuilder.FragmentationFragmentationAutomation("127.0.0.1", "2050", "", "5", "3", "3", "0", "/home/heber/workspace_C/molecuilder/tests/regression/Fragmentation/ParseSaveFragmentationResults/pre/results.dat", "0", "0", "0", "0")
+# =========================== Stored Session END ===========================
Index: tests/regression/Fragmentation/ParseSaveFragmentResults/pre/results.dat
===================================================================
--- tests/regression/Fragmentation/ParseSaveFragmentResults/pre/results.dat	(revision 73a5f79e4f9ad7064ccf8574d08f5daf61ce8498)
+++ tests/regression/Fragmentation/ParseSaveFragmentResults/pre/results.dat	(revision 73a5f79e4f9ad7064ccf8574d08f5daf61ce8498)
@@ -0,0 +1,10 @@
+22 serialization::archive 10 0 2 0 0 0 0 0 3 0 1 0 5 1 0 6 2 0 5 6 3 0 1 1 2 3 0 2 0 2 1 2 0 2 0 0 1 1 0 2 3 0 5 0 5 7 8 11 -1 5 0 6 9 10 12 -1 8 0 5 6 7 8 9 10 11 12 3 0 5 5 8 3 0 2 0 2 1 2 0 2 0 0 1 1 0 2 0 0 3 0 0 0 1 0 3 -40.077095023865645 13.42793733284492 32.51477733403145 -6.5485700255216468 -0.10038201047693462 5.0000000000000178 39.844151065398044 -119.21500872014148 17 0 -11.148140703555685 -0.94271869218355042 -0.5430993079587928 -0.54293973244202665 -0.54232309076680041 0.2946080854274703 0.34970929418276003 0.3502394925620062 0.35035970537504513 0.92724927449724981 0.92747598978237455 0.92851198556340275 1.3213560027903928 1.3505626523479759 1.3519453674365389 1.3522910314714007 1.9525491096624021 1 0
+0 0 0 5 0 3 0 -0.00097142871311288546 0.001223447254553411 5.0249629586040271e-14 3 0 -3.2733604507485369e-05 -0.00098269446908094693 0.0014022817756593753 3 0 -3.2733604507501524e-05 -0.00098269446907905955 -0.0014022817756524919 3 0 0.0011176708760569642 0.00076103111816361313 -4.2937665656200504e-15 3 0 -8.0774953863826937e-05 -1.9089434590058296e-05 -4.3588615673519057e-15 1 0
+1 1 0
+2 0 0 0 37.794519771578464 37.794519771578464 37.794519771578464 5 0 0 0 0 0 0 0 0 0 0 5 0 3 0 11.130486072729857 12.307785363614528 11.130486072729857 3 0 11.130486072729857 13.496423010430671 9.4486299428946161 3 0 11.130486072729857 13.496423010430671 12.8123422025651 3 0 9.4486299428946161 11.117257990809806 11.130486072729857 3 0 12.815393396740683 11.115264887701173 11.130486072729857 5 0 6 1 1 1 1 0.19292902946472168 0.17287399999999997 0 0.0081779956817626953 0.0081330000000000013 0 4.0571198671525548e-07 9.9999999999999995e-07 2 -40.077095023865546 13.42793733284492 32.514777334031365 -6.5485700255216477 -0.10038201047693462 5.000000000000008 39.844151065397888 -119.21500872014106 17 0 -11.14814070355564 -0.94271869218356674 -0.54309930795880834 -0.54293973244204741 -0.54232309076681517 0.29460808542744005 0.34970929418274099 0.35023949256198394 0.35035970537503386 0.9272492744972276 0.9274759897823549 0.92851198556339865 1.3213560027903779 1.3505626523479612 1.3519453674364903 1.3522910314713876 1.9525491096624088
+3 5 0 3 0 0.00097142871315757367 -0.0012234472545053932 5.2147863220010912e-14 3 0 3.2733604506754725e-05 0.00098269446908105795 0.0014022817756584871 3 0 3.2733604506849322e-05 0.0009826944690902728 -0.0014022817756584871 3 0 -0.0011176708760494147 -0.00076103111816028246 -3.9975172614093481e-15 3 0 8.0774953874707123e-05 1.9089434589947274e-05 -4.5090065497904424e-15
+4
+5 0 0 0 37.794519771578464 37.794519771578464 37.794519771578464 5 0 0 0 0 0 0 0 0 0 0 5 0 3 0 13.490753832464934 10.637267589710758 11.130486072729857 3 0 13.490753832464934 9.4486299428946161 9.4486299428946161 3 0 13.490753832464934 9.4486299428946161 12.8123422025651 3 0 15.172609962300175 11.827794962515481 11.130486072729857 3 0 11.805846508454108 11.829788065624115 11.130486072729857 5 0 6 1 1 1 1 0.132843017578125 0.11093600000000001 0 0.0051279067993164062 0.0051059999999999994 0 4.0571236623974252e-07 9.9999999999999995e-07 3 -78.984317265663137 42.354144005167818 79.903236593585717 -12.437860729405935 -0.19133824172895686 9.0000000000000586 78.628676430189145 -267.24117532347196 30 0 -11.152659768550606 -11.15242451154336 -1.0225826167313268 -0.83823846895084309 -0.60316968457055042 -0.60301501955425385 -0.49792275928522672 -0.48554683276315141 -0.48531392003484908 0.27497213972333967 0.33954634852876264 0.33962045345389924 0.34634960757441746 0.36652207980012153 0.36674371206463985 0.42432853085418415 0.91698056490379076 0.91733451779655562 0.95938552361383878 1.0783373468114767 1.0786311432159261 1.0799081427028798 1.2778564797244578 1.3645138365943332 1.3649101609328069 1.3723339872349947 1.3726314318850914 1.4461806380659645 1.9428110846236297 2.3096165633536305
+6 8 0 3 0 0.0021170972923365561 -0.0008596102763087643 9.7782875218957691e-14 3 0 -0.0021170972922983644 0.0008596102763540614 1.0043915600859457e-13 3 0 0.0036600670440157801 -0.003400957167937646 0.0011241539557951263 3 0 0.0036600670440181948 -0.0034009571679400885 -0.0011241539557962366 3 0 -0.0036600670440190275 0.003400957167942531 0.0011241539557911295 3 0 -0.0036600670440221084 0.0034009571679456396 -0.0011241539557862446 3 0 0.0045614070472550505 -0.0020689692805928583 -7.7286223356141867e-15 3 0 -0.0045614070472641544 0.0020689692805978543 -7.9250025040428786e-15
+7
+8 0 0 0 37.794519771578464 37.794519771578464 37.794519771578464 5 0 0 0 0 0 0 0 0 0 0 8 0 3 0 11.130486072729857 12.307785363614528 11.130486072729857 3 0 13.490753832464934 10.637267589710758 11.130486072729857 3 0 11.130486072729857 13.496423010430671 9.4486299428946161 3 0 11.130486072729857 13.496423010430671 12.8123422025651 3 0 13.490753832464934 9.4486299428946161 9.4486299428946161 3 0 13.490753832464934 9.4486299428946161 12.8123422025651 3 0 9.4486299428946161 11.117257990809806 11.130486072729857 3 0 15.172609962300175 11.827794962515481 11.130486072729857 8 0 6 6 1 1 1 1 1 1 0.96324896812438965 0.94148000000000009 0 0.03135991096496582 0.031313999999999953 0 1.7578180412962215e-07 9.9999999999999995e-07 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0