Index: tests/Python/ForceAnnealing/post/five_carbon_test_bondgraph.data
===================================================================
--- tests/Python/ForceAnnealing/post/five_carbon_test_bondgraph.data	(revision 0c4f2420d34feb2663aef0867efac7de987442ae)
+++ tests/Python/ForceAnnealing/post/five_carbon_test_bondgraph.data	(revision 90ece9cde4683106df17fffeb197e4d20868c20b)
@@ -2,96 +2,96 @@
 # Box	20	0	0	0	20	0	0	0	20
 C	1	6	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	7.6	10	10	0	0	0	0	0	0	1	3	0	0	
-C	3	8.7	10	10	0	0	0	0	0	0	2	4	0	0	
-C	4	10.8	10	10	0	0	0	0	0	0	3	5	0	0	
+C	2	7.6	10	10	0	0	0	-0.264589	0	0	1	3	0	0	
+C	3	8.7	10	10	0	0	0	0.529177	0	0	2	4	0	0	
+C	4	10.8	10	10	0	0	0	-0.264589	0	0	3	5	0	0	
 C	5	12.4	10	10	0	0	0	0	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	6	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	7.57354	10	10	0	0	0	-0.264589	0	0	1	3	0	0	
-C	3	8.75292	10	10	0	0	0	0.529177	0	0	2	4	0	0	
-C	4	10.7735	10	10	0	0	0	-0.264589	0	0	3	5	0	0	
-C	5	12.4	10	10	0	0	0	0	0	0	4	0	0	0	
+C	1	6	10	10	0	0	0	-0.014002	0	0	2	0	0	0	
+C	2	7.57354	10	10	0	0	0	-0.208581	0	0	1	3	0	0	
+C	3	8.75292	10	10	0	0	0	0.445144	0	0	2	4	0	0	
+C	4	10.7735	10	10	0	0	0	-0.208538	0	0	3	5	0	0	
+C	5	12.4	10	10	0	0	0	-0.0140232	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.97149	10	10	0	0	0	-0.014002	0	0	2	0	0	0	
-C	2	7.49973	10	10	0	0	0	-0.208581	0	0	1	3	0	0	
-C	3	8.95748	10	10	0	0	0	0.445144	0	0	2	4	0	0	
-C	4	10.6998	10	10	0	0	0	-0.208538	0	0	3	5	0	0	
-C	5	12.3715	10	10	0	0	0	-0.0140232	0	0	4	0	0	0	
+C	1	5.97149	10	10	0	0	0	-0.0379738	0	0	2	0	0	0	
+C	2	7.49973	10	10	0	0	0	-0.0373017	0	0	1	3	0	0	
+C	3	8.95748	10	10	0	0	0	0.150588	0	0	2	4	0	0	
+C	4	10.6998	10	10	0	0	0	-0.0373705	0	0	3	5	0	0	
+C	5	12.3715	10	10	0	0	0	-0.037942	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.93924	10	10	0	0	0	-0.0379738	0	0	2	0	0	0	
-C	2	7.49102	10	10	0	0	0	-0.0373017	0	0	1	3	0	0	
-C	3	9.03941	10	10	0	0	0	0.150588	0	0	2	4	0	0	
-C	4	10.6911	10	10	0	0	0	-0.0373705	0	0	3	5	0	0	
-C	5	12.3392	10	10	0	0	0	-0.037942	0	0	4	0	0	0	
+C	1	5.93924	10	10	0	0	0	-0.0255169	0	0	2	0	0	0	
+C	2	7.49102	10	10	0	0	0	-0.00179391	0	0	1	3	0	0	
+C	3	9.03941	10	10	0	0	0	0.054664	0	0	2	4	0	0	
+C	4	10.6911	10	10	0	0	0	-0.00189975	0	0	3	5	0	0	
+C	5	12.3392	10	10	0	0	0	-0.0254534	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90802	10	10	0	0	0	-0.0255169	0	0	2	0	0	0	
-C	2	7.49975	10	10	0	0	0	-0.00179391	0	0	1	3	0	0	
-C	3	9.08428	10	10	0	0	0	0.054664	0	0	2	4	0	0	
-C	4	10.6998	10	10	0	0	0	-0.00189975	0	0	3	5	0	0	
-C	5	12.3082	10	10	0	0	0	-0.0254534	0	0	4	0	0	0	
+C	1	5.90802	10	10	0	0	0	-0.0043763	0	0	2	0	0	0	
+C	2	7.49975	10	10	0	0	0	-0.00381008	0	0	1	3	0	0	
+C	3	9.08428	10	10	0	0	0	0.0163992	0	0	2	4	0	0	
+C	4	10.6998	10	10	0	0	0	-0.00376774	0	0	3	5	0	0	
+C	5	12.3082	10	10	0	0	0	-0.00444509	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90803	10	10	0	0	0	-0.0043763	0	0	2	0	0	0	
-C	2	7.49176	10	10	0	0	0	-0.00381008	0	0	1	3	0	0	
-C	3	9.10147	10	10	0	0	0	0.0163992	0	0	2	4	0	0	
-C	4	10.6908	10	10	0	0	0	-0.00376774	0	0	3	5	0	0	
-C	5	12.3079	10	10	0	0	0	-0.00444509	0	0	4	0	0	0	
+C	1	5.90803	10	10	0	0	0	-0.00860971	0	0	2	0	0	0	
+C	2	7.49176	10	10	0	0	0	0.013748	0	0	1	3	0	0	
+C	3	9.10147	10	10	0	0	0	-0.0107846	0	0	2	4	0	0	
+C	4	10.6908	10	10	0	0	0	0.0146953	0	0	3	5	0	0	
+C	5	12.3079	10	10	0	0	0	-0.00904893	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90707	10	10	0	0	0	-0.00860971	0	0	2	0	0	0	
-C	2	7.49521	10	10	0	0	0	0.013748	0	0	1	3	0	0	
-C	3	9.09579	10	10	0	0	0	-0.0107846	0	0	2	4	0	0	
-C	4	10.6951	10	10	0	0	0	0.0146953	0	0	3	5	0	0	
-C	5	12.3069	10	10	0	0	0	-0.00904893	0	0	4	0	0	0	
+C	1	5.90707	10	10	0	0	0	-0.00627604	0	0	2	0	0	0	
+C	2	7.49521	10	10	0	0	0	0.00658296	0	0	1	3	0	0	
+C	3	9.09579	10	10	0	0	0	-0.000672055	0	0	2	4	0	0	
+C	4	10.6951	10	10	0	0	0	0.00660942	0	0	3	5	0	0	
+C	5	12.3069	10	10	0	0	0	-0.00624429	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90506	10	10	0	0	0	-0.00627604	0	0	2	0	0	0	
-C	2	7.49716	10	10	0	0	0	0.00658296	0	0	1	3	0	0	
-C	3	9.09547	10	10	0	0	0	-0.000672055	0	0	2	4	0	0	
-C	4	10.6973	10	10	0	0	0	0.00660942	0	0	3	5	0	0	
-C	5	12.305	10	10	0	0	0	-0.00624429	0	0	4	0	0	0	
+C	1	5.90506	10	10	0	0	0	-0.0041805	0	0	2	0	0	0	
+C	2	7.49716	10	10	0	0	0	0.00328619	0	0	1	3	0	0	
+C	3	9.09547	10	10	0	0	0	0.0018627	0	0	2	4	0	0	
+C	4	10.6973	10	10	0	0	0	0.00310627	0	0	3	5	0	0	
+C	5	12.305	10	10	0	0	0	-0.00407466	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90296	10	10	0	0	0	-0.0041805	0	0	2	0	0	0	
-C	2	7.4988	10	10	0	0	0	0.00328619	0	0	1	3	0	0	
-C	3	9.09605	10	10	0	0	0	0.0018627	0	0	2	4	0	0	
-C	4	10.6989	10	10	0	0	0	0.00310627	0	0	3	5	0	0	
-C	5	12.3033	10	10	0	0	0	-0.00407466	0	0	4	0	0	0	
+C	1	5.90296	10	10	0	0	0	-0.00220138	0	0	2	0	0	0	
+C	2	7.4988	10	10	0	0	0	0.00074614	0	0	1	3	0	0	
+C	3	9.09605	10	10	0	0	0	0.00296339	0	0	2	4	0	0	
+C	4	10.6989	10	10	0	0	0	0.000820225	0	0	3	5	0	0	
+C	5	12.3033	10	10	0	0	0	-0.00232838	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90167	10	10	0	0	0	-0.00220138	0	0	2	0	0	0	
-C	2	7.49933	10	10	0	0	0	0.00074614	0	0	1	3	0	0	
-C	3	9.0975	10	10	0	0	0	0.00296339	0	0	2	4	0	0	
-C	4	10.6996	10	10	0	0	0	0.000820225	0	0	3	5	0	0	
-C	5	12.302	10	10	0	0	0	-0.00232838	0	0	4	0	0	0	
+C	1	5.90167	10	10	0	0	0	-0.00123827	0	0	2	0	0	0	
+C	2	7.49933	10	10	0	0	0	0.00026988	0	0	1	3	0	0	
+C	3	9.0975	10	10	0	0	0	0.00207967	0	0	2	4	0	0	
+C	4	10.6996	10	10	0	0	0	0.000158753	0	0	3	5	0	0	
+C	5	12.302	10	10	0	0	0	-0.00127003	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90028	10	10	0	0	0	-0.00123827	0	0	2	0	0	0	
-C	2	7.49949	10	10	0	0	0	0.00026988	0	0	1	3	0	0	
-C	3	9.10006	10	10	0	0	0	0.00207967	0	0	2	4	0	0	
-C	4	10.6996	10	10	0	0	0	0.000158753	0	0	3	5	0	0	
-C	5	12.3006	10	10	0	0	0	-0.00127003	0	0	4	0	0	0	
+C	1	5.90028	10	10	0	0	0	-0.00041805	0	0	2	0	0	0	
+C	2	7.49949	10	10	0	0	0	0.000719681	0	0	1	3	0	0	
+C	3	9.10006	10	10	0	0	0	-0.000545053	0	0	2	4	0	0	
+C	4	10.6996	10	10	0	0	0	0.000772599	0	0	3	5	0	0	
+C	5	12.3006	10	10	0	0	0	-0.000529177	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90018	10	10	0	0	0	-0.00041805	0	0	2	0	0	0	
-C	2	7.49988	10	10	0	0	0	0.000719681	0	0	1	3	0	0	
-C	3	9.09986	10	10	0	0	0	-0.000545053	0	0	2	4	0	0	
-C	4	10.6998	10	10	0	0	0	0.000772599	0	0	3	5	0	0	
-C	5	12.3003	10	10	0	0	0	-0.000529177	0	0	4	0	0	0	
+C	1	5.90018	10	10	0	0	0	-0.000158753	0	0	2	0	0	0	
+C	2	7.49988	10	10	0	0	0	0.00014817	0	0	1	3	0	0	
+C	3	9.09986	10	10	0	0	0	-2.11671e-05	0	0	2	4	0	0	
+C	4	10.6998	10	10	0	0	0	0.000296339	0	0	3	5	0	0	
+C	5	12.3003	10	10	0	0	0	-0.000264589	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90014	10	10	0	0	0	-0.000158753	0	0	2	0	0	0	
-C	2	7.49996	10	10	0	0	0	0.00014817	0	0	1	3	0	0	
-C	3	9.09987	10	10	0	0	0	-2.11671e-05	0	0	2	4	0	0	
-C	4	10.6999	10	10	0	0	0	0.000296339	0	0	3	5	0	0	
-C	5	12.3002	10	10	0	0	0	-0.000264589	0	0	4	0	0	0	
+C	1	5.90014	10	10	0	0	0	-9.52519e-05	0	0	2	0	0	0	
+C	2	7.49996	10	10	0	0	0	4.7626e-05	0	0	1	3	0	0	
+C	3	9.09987	10	10	0	0	0	6.35013e-05	0	0	2	4	0	0	
+C	4	10.6999	10	10	0	0	0	0.000142878	0	0	3	5	0	0	
+C	5	12.3002	10	10	0	0	0	-0.000158753	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90011	10	10	0	0	0	-9.52519e-05	0	0	2	0	0	0	
-C	2	7.5	10	10	0	0	0	4.7626e-05	0	0	1	3	0	0	
-C	3	9.09989	10	10	0	0	0	6.35013e-05	0	0	2	4	0	0	
-C	4	10.7	10	10	0	0	0	0.000142878	0	0	3	5	0	0	
-C	5	12.3001	10	10	0	0	0	-0.000158753	0	0	4	0	0	0	
+C	1	5.90011	10	10	0	0	0	-5.82095e-05	0	0	2	0	0	0	
+C	2	7.5	10	10	0	0	0	0	0	0	1	3	0	0	
+C	3	9.09989	10	10	0	0	0	0.000116419	0	0	2	4	0	0	
+C	4	10.7	10	10	0	0	0	-5.29177e-06	0	0	3	5	0	0	
+C	5	12.3001	10	10	0	0	0	-5.29177e-05	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90008	10	10	0	0	0	-5.82095e-05	0	0	2	0	0	0	
-C	2	7.5	10	10	0	0	0	0	0	0	1	3	0	0	
-C	3	9.09993	10	10	0	0	0	0.000116419	0	0	2	4	0	0	
-C	4	10.7	10	10	0	0	0	-5.29177e-06	0	0	3	5	0	0	
-C	5	12.3	10	10	0	0	0	-5.29177e-05	0	0	4	0	0	0	
+C	1	5.90008	10	10	0	0	0	-4.23342e-05	0	0	2	0	0	0	
+C	2	7.5	10	10	0	0	0	5.29177e-06	0	0	1	3	0	0	
+C	3	9.09993	10	10	0	0	0	7.40848e-05	0	0	2	4	0	0	
+C	4	10.7	10	10	0	0	0	-3.70424e-05	0	0	3	5	0	0	
+C	5	12.3	10	10	0	0	0	1.35525e-21	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.90004	10	10	0	0	0	-4.23342e-05	0	0	2	0	0	0	
-C	2	7.50001	10	10	0	0	0	5.29177e-06	0	0	1	3	0	0	
-C	3	9.09999	10	10	0	0	0	7.40848e-05	0	0	2	4	0	0	
-C	4	10.6999	10	10	0	0	0	-3.70424e-05	0	0	3	5	0	0	
-C	5	12.3	10	10	0	0	0	1.35525e-21	0	0	4	0	0	0	
+C	1	5.90004	10	10	0	0	0	0	0	0	2	0	0	0	
+C	2	7.50001	10	10	0	0	0	0	0	0	1	3	0	0	
+C	3	9.09999	10	10	0	0	0	0	0	0	2	4	0	0	
+C	4	10.6999	10	10	0	0	0	0	0	0	3	5	0	0	
+C	5	12.3	10	10	0	0	0	0	0	0	4	0	0	0	
Index: tests/Python/ForceAnnealing/post/five_carbon_test_no-bondgraph.data
===================================================================
--- tests/Python/ForceAnnealing/post/five_carbon_test_no-bondgraph.data	(revision 0c4f2420d34feb2663aef0867efac7de987442ae)
+++ tests/Python/ForceAnnealing/post/five_carbon_test_no-bondgraph.data	(revision 90ece9cde4683106df17fffeb197e4d20868c20b)
@@ -91,34 +91,4 @@
 C	5	12.3858	10	10	0	0	0	5.29177e-05	0	0	4	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.98595	10	10	0	0	0	0.000137586	0	0	2	0	0	0	
-C	2	7.58621	10	10	0	0	0	-0.000211671	0	0	1	3	0	0	
-C	3	9.18607	10	10	0	0	0	3.70424e-05	0	0	2	4	0	0	
-C	4	10.786	10	10	0	0	0	-6.8793e-05	0	0	3	5	0	0	
-C	5	12.3858	10	10	0	0	0	0.000105835	0	0	4	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.98595	10	10	0	0	0	0.000137586	0	0	2	0	0	0	
-C	2	7.58621	10	10	0	0	0	-0.000211671	0	0	1	3	0	0	
-C	3	9.18607	10	10	0	0	0	3.70424e-05	0	0	2	4	0	0	
-C	4	10.786	10	10	0	0	0	-6.8793e-05	0	0	3	5	0	0	
-C	5	12.3858	10	10	0	0	0	0.000105835	0	0	4	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.98595	10	10	0	0	0	0.000137586	0	0	2	0	0	0	
-C	2	7.58621	10	10	0	0	0	-0.000211671	0	0	1	3	0	0	
-C	3	9.18607	10	10	0	0	0	3.70424e-05	0	0	2	4	0	0	
-C	4	10.786	10	10	0	0	0	-6.8793e-05	0	0	3	5	0	0	
-C	5	12.3858	10	10	0	0	0	0.000105835	0	0	4	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.98595	10	10	0	0	0	0.000137586	0	0	2	0	0	0	
-C	2	7.58621	10	10	0	0	0	-0.000211671	0	0	1	3	0	0	
-C	3	9.18607	10	10	0	0	0	3.70424e-05	0	0	2	4	0	0	
-C	4	10.786	10	10	0	0	0	-6.8793e-05	0	0	3	5	0	0	
-C	5	12.3858	10	10	0	0	0	0.000105835	0	0	4	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	5.98595	10	10	0	0	0	0.000137586	0	0	2	0	0	0	
-C	2	7.58621	10	10	0	0	0	-0.000211671	0	0	1	3	0	0	
-C	3	9.18607	10	10	0	0	0	3.70424e-05	0	0	2	4	0	0	
-C	4	10.786	10	10	0	0	0	-6.8793e-05	0	0	3	5	0	0	
-C	5	12.3858	10	10	0	0	0	0.000105835	0	0	4	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
 C	1	5.98595	10	10	0	0	0	0	0	0	2	0	0	0	
 C	2	7.58621	10	10	0	0	0	0	0	0	1	3	0	0	
Index: tests/Python/ForceAnnealing/post/two_carbon_test_bondgraph.data
===================================================================
--- tests/Python/ForceAnnealing/post/two_carbon_test_bondgraph.data	(revision 0c4f2420d34feb2663aef0867efac7de987442ae)
+++ tests/Python/ForceAnnealing/post/two_carbon_test_bondgraph.data	(revision 90ece9cde4683106df17fffeb197e4d20868c20b)
@@ -1,13 +1,13 @@
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
 # Box	20	0	0	0	20	0	0	0	20
-C	1	7.6	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.7	10	10	0	0	0	0	0	0	1	0	0	0	
+C	1	7.6	10	10	0	0	0	-0.264589	0	0	2	0	0	0	
+C	2	8.7	10	10	0	0	0	0.264589	0	0	1	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.57354	10	10	0	0	0	-0.264589	0	0	2	0	0	0	
-C	2	8.72646	10	10	0	0	0	0.264589	0	0	1	0	0	0	
+C	1	7.57354	10	10	0	0	0	-0.236585	0	0	2	0	0	0	
+C	2	8.72646	10	10	0	0	0	0.236585	0	0	1	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35001	10	10	0	0	0	-0.236585	0	0	2	0	0	0	
-C	2	8.94999	10	10	0	0	0	0.236585	0	0	1	0	0	0	
+C	1	7.35001	10	10	0	0	0	-1.05835e-05	0	0	2	0	0	0	
+C	2	8.94999	10	10	0	0	0	1.05835e-05	0	0	1	0	0	0	
 # ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	-1.05835e-05	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	1.05835e-05	0	0	1	0	0	0	
+C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
+C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
Index: tests/Python/ForceAnnealing/post/two_carbon_test_no-bondgraph.data
===================================================================
--- tests/Python/ForceAnnealing/post/two_carbon_test_no-bondgraph.data	(revision 0c4f2420d34feb2663aef0867efac7de987442ae)
+++ tests/Python/ForceAnnealing/post/two_carbon_test_no-bondgraph.data	(revision 90ece9cde4683106df17fffeb197e4d20868c20b)
@@ -12,38 +12,2 @@
 C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
 C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
-# ATOMDATA	type	Id	x=3	u=3	F=3	neighbors=4
-C	1	7.35	10	10	0	0	0	0	0	0	2	0	0	0	
-C	2	8.95	10	10	0	0	0	0	0	0	1	0	0	0	
Index: tests/Python/ForceAnnealing/testsuite-python-forceannealing-ising.at
===================================================================
--- tests/Python/ForceAnnealing/testsuite-python-forceannealing-ising.at	(revision 0c4f2420d34feb2663aef0867efac7de987442ae)
+++ tests/Python/ForceAnnealing/testsuite-python-forceannealing-ising.at	(revision 90ece9cde4683106df17fffeb197e4d20868c20b)
@@ -24,5 +24,5 @@
 
 file=two_carbon_test.data
-AT_CHECK([../../run ${abs_top_srcdir}/tests/Python/ForceAnnealing/pre/ising_model_chain.py ./$file ./ 15 2 "0"], 0, [stdout], [ignore])
+AT_CHECK([../../run ${abs_top_srcdir}/tests/Python/ForceAnnealing/pre/ising_model_chain.py ./$file ./ 3 2 "0"], 0, [stdout], [ignore])
 AT_CHECK([grep "Largest remaining force components.*e-05" stdout], 0, [ignore], [ignore])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/Python/ForceAnnealing/post/two_carbon_test_no-bondgraph.data], 0, [ignore], [ignore])
@@ -37,6 +37,6 @@
 
 file=five_carbon_test.data
-AT_CHECK([../../run ${abs_top_srcdir}/tests/Python/ForceAnnealing/pre/ising_model_chain.py ./$file ./ 20 5 "0"], 0, [stdout], [ignore])
-AT_CHECK([grep "Largest remaining force components.*e-05" stdout], 0, [ignore], [ignore])
+AT_CHECK([../../run ${abs_top_srcdir}/tests/Python/ForceAnnealing/pre/ising_model_chain.py ./$file ./ 15 5 "0"], 0, [stdout], [ignore])
+AT_CHECK([grep "Largest remaining force components.*0.0001" stdout], 0, [ignore], [ignore])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/Python/ForceAnnealing/post/five_carbon_test_no-bondgraph.data], 0, [ignore], [ignore])
 