Index: tests/regression/Analysis/6/post/hydrogenbox_histogram.dat
===================================================================
--- tests/regression/Analysis/6/post/hydrogenbox_histogram.dat	(revision cd7a874697981628f16debf304ae5c1ff4d0f0ce)
+++ tests/regression/Analysis/6/post/hydrogenbox_histogram.dat	(revision 92e5cbdb87cf8cd20127f2dff627b843dfad5ae2)
@@ -1,361 +1,361 @@
-BinStart	Count
-0	0
-1	0
-2	0
-3	0
-4	0
-5	0
-6	0
-7	0
-8	0
-9	0
-10	0
-11	0
-12	0
-13	0
-14	0
-15	0
-16	0
-17	0
-18	0
-19	0
-20	0
-21	0
-22	0
-23	0
-24	0
-25	0
-26	0
-27	0
-28	0
-29	0
-30	0
-31	0
-32	0
-33	0
-34	0
-35	0
-36	0
-37	0
-38	0
-39	0
-40	0
-41	0
-42	0
-43	0
-44	0
-45	0
-46	0
-47	0
-48	0
-49	0
-50	0
-51	0
-52	0
-53	0
-54	0
-55	0
-56	0
-57	0
-58	0
-59	0
-60	0
-61	0
-62	0
-63	0
-64	0
-65	0
-66	0
-67	0
-68	0
-69	0
-70	0
-71	0
-72	0
-73	0
-74	0
-75	0
-76	0
-77	0
-78	0
-79	0
-80	0
-81	0
-82	0
-83	0
-84	0
-85	0
-86	0
-87	0
-88	0
-89	0
-90	0
-91	0
-92	0
-93	0
-94	0
-95	0
-96	0
-97	0
-98	0
-99	0
-100	0
-101	0
-102	0
-103	0
-104	0
-105	0
-106	0
-107	0
-108	0
-109	0
-110	0
-111	0
-112	0
-113	0
-114	0
-115	0
-116	0
-117	0
-118	0
-119	0
-120	0
-121	0
-122	0
-123	0
-124	0
-125	0
-126	0
-127	0
-128	0
-129	0
-130	0
-131	0
-132	0
-133	0
-134	0
-135	0
-136	0
-137	0
-138	0
-139	0
-140	0
-141	0
-142	0
-143	0
-144	0
-145	0
-146	0
-147	0
-148	0
-149	0
-150	0
-151	0
-152	0
-153	0
-154	0
-155	0
-156	0
-157	0
-158	0
-159	0
-160	0
-161	0
-162	0
-163	0
-164	0
-165	0
-166	0
-167	0
-168	0
-169	0
-170	0
-171	0
-172	0
-173	0
-174	0
-175	0
-176	0
-177	0
-178	0
-179	0
-180	0
-181	0
-182	0
-183	0
-184	0
-185	0
-186	0
-187	0
-188	0
-189	0
-190	0
-191	0
-192	0
-193	0
-194	0
-195	0
-196	0
-197	0
-198	0
-199	0
-200	0
-201	0
-202	0
-203	0
-204	0
-205	0
-206	0
-207	0
-208	0
-209	0
-210	0
-211	0
-212	0
-213	0
-214	0
-215	0
-216	0
-217	0
-218	0
-219	0
-220	0
-221	0
-222	0
-223	0
-224	0
-225	0
-226	0
-227	0
-228	0
-229	0
-230	0
-231	0
-232	0
-233	0
-234	0
-235	0
-236	0
-237	0
-238	0
-239	0
-240	0
-241	0
-242	0
-243	0
-244	0
-245	0
-246	0
-247	0
-248	0
-249	0
-250	0
-251	0
-252	0
-253	0
-254	0
-255	0
-256	0
-257	0
-258	0
-259	0
-260	0
-261	0
-262	0
-263	0
-264	0
-265	0
-266	0
-267	0
-268	0
-269	0
-270	0
-271	0
-272	0
-273	0
-274	0
-275	0
-276	0
-277	0
-278	0
-279	0
-280	0
-281	0
-282	0
-283	0
-284	0
-285	0
-286	0
-287	0
-288	0
-289	0
-290	0
-291	0
-292	0
-293	0
-294	0
-295	0
-296	0
-297	0
-298	0
-299	0
-300	0
-301	0
-302	0
-303	0
-304	0
-305	0
-306	0
-307	0
-308	0
-309	0
-310	0
-311	0
-312	0
-313	0
-314	0
-315	0
-316	0
-317	0
-318	0
-319	0
-320	0
-321	0
-322	0
-323	0
-324	0
-325	0
-326	0
-327	0
-328	0
-329	0
-330	0
-331	0
-332	0
-333	0
-334	0
-335	0
-336	0
-337	0
-338	0
-339	0
-340	0
-341	0
-342	0
-343	0
-344	0
-345	0
-346	0
-347	0
-348	0
-349	0
-350	0
-351	0
-352	0
-353	0
-354	0
-355	0
-356	0
-357	0
-358	0
-359	0
+BinStart	BinCenter	BinEnd	Count
+0	0.5	1	0
+1	1.5	2	0
+2	2.5	3	0
+3	3.5	4	0
+4	4.5	5	0
+5	5.5	6	0
+6	6.5	7	0
+7	7.5	8	0
+8	8.5	9	0
+9	9.5	10	0
+10	10.5	11	0
+11	11.5	12	0
+12	12.5	13	0
+13	13.5	14	0
+14	14.5	15	0
+15	15.5	16	0
+16	16.5	17	0
+17	17.5	18	0
+18	18.5	19	0
+19	19.5	20	0
+20	20.5	21	0
+21	21.5	22	0
+22	22.5	23	0
+23	23.5	24	0
+24	24.5	25	0
+25	25.5	26	0
+26	26.5	27	0
+27	27.5	28	0
+28	28.5	29	0
+29	29.5	30	0
+30	30.5	31	0
+31	31.5	32	0
+32	32.5	33	0
+33	33.5	34	0
+34	34.5	35	0
+35	35.5	36	0
+36	36.5	37	0
+37	37.5	38	0
+38	38.5	39	0
+39	39.5	40	0
+40	40.5	41	0
+41	41.5	42	0
+42	42.5	43	0
+43	43.5	44	0
+44	44.5	45	0
+45	45.5	46	0
+46	46.5	47	0
+47	47.5	48	0
+48	48.5	49	0
+49	49.5	50	0
+50	50.5	51	0
+51	51.5	52	0
+52	52.5	53	0
+53	53.5	54	0
+54	54.5	55	0
+55	55.5	56	0
+56	56.5	57	0
+57	57.5	58	0
+58	58.5	59	0
+59	59.5	60	0
+60	60.5	61	0
+61	61.5	62	0
+62	62.5	63	0
+63	63.5	64	0
+64	64.5	65	0
+65	65.5	66	0
+66	66.5	67	0
+67	67.5	68	0
+68	68.5	69	0
+69	69.5	70	0
+70	70.5	71	0
+71	71.5	72	0
+72	72.5	73	0
+73	73.5	74	0
+74	74.5	75	0
+75	75.5	76	0
+76	76.5	77	0
+77	77.5	78	0
+78	78.5	79	0
+79	79.5	80	0
+80	80.5	81	0
+81	81.5	82	0
+82	82.5	83	0
+83	83.5	84	0
+84	84.5	85	0
+85	85.5	86	0
+86	86.5	87	0
+87	87.5	88	0
+88	88.5	89	0
+89	89.5	90	0
+90	90.5	91	0
+91	91.5	92	0
+92	92.5	93	0
+93	93.5	94	0
+94	94.5	95	0
+95	95.5	96	0
+96	96.5	97	0
+97	97.5	98	0
+98	98.5	99	0
+99	99.5	100	0
+100	100.5	101	0
+101	101.5	102	0
+102	102.5	103	0
+103	103.5	104	0
+104	104.5	105	0
+105	105.5	106	0
+106	106.5	107	0
+107	107.5	108	0
+108	108.5	109	0
+109	109.5	110	0
+110	110.5	111	0
+111	111.5	112	0
+112	112.5	113	0
+113	113.5	114	0
+114	114.5	115	0
+115	115.5	116	0
+116	116.5	117	0
+117	117.5	118	0
+118	118.5	119	0
+119	119.5	120	0
+120	120.5	121	0
+121	121.5	122	0
+122	122.5	123	0
+123	123.5	124	0
+124	124.5	125	0
+125	125.5	126	0
+126	126.5	127	0
+127	127.5	128	0
+128	128.5	129	0
+129	129.5	130	0
+130	130.5	131	0
+131	131.5	132	0
+132	132.5	133	0
+133	133.5	134	0
+134	134.5	135	0
+135	135.5	136	0
+136	136.5	137	0
+137	137.5	138	0
+138	138.5	139	0
+139	139.5	140	0
+140	140.5	141	0
+141	141.5	142	0
+142	142.5	143	0
+143	143.5	144	0
+144	144.5	145	0
+145	145.5	146	0
+146	146.5	147	0
+147	147.5	148	0
+148	148.5	149	0
+149	149.5	150	0
+150	150.5	151	0
+151	151.5	152	0
+152	152.5	153	0
+153	153.5	154	0
+154	154.5	155	0
+155	155.5	156	0
+156	156.5	157	0
+157	157.5	158	0
+158	158.5	159	0
+159	159.5	160	0
+160	160.5	161	0
+161	161.5	162	0
+162	162.5	163	0
+163	163.5	164	0
+164	164.5	165	0
+165	165.5	166	0
+166	166.5	167	0
+167	167.5	168	0
+168	168.5	169	0
+169	169.5	170	0
+170	170.5	171	0
+171	171.5	172	0
+172	172.5	173	0
+173	173.5	174	0
+174	174.5	175	0
+175	175.5	176	0
+176	176.5	177	0
+177	177.5	178	0
+178	178.5	179	0
+179	179.5	180	0
+180	180.5	181	0
+181	181.5	182	0
+182	182.5	183	0
+183	183.5	184	0
+184	184.5	185	0
+185	185.5	186	0
+186	186.5	187	0
+187	187.5	188	0
+188	188.5	189	0
+189	189.5	190	0
+190	190.5	191	0
+191	191.5	192	0
+192	192.5	193	0
+193	193.5	194	0
+194	194.5	195	0
+195	195.5	196	0
+196	196.5	197	0
+197	197.5	198	0
+198	198.5	199	0
+199	199.5	200	0
+200	200.5	201	0
+201	201.5	202	0
+202	202.5	203	0
+203	203.5	204	0
+204	204.5	205	0
+205	205.5	206	0
+206	206.5	207	0
+207	207.5	208	0
+208	208.5	209	0
+209	209.5	210	0
+210	210.5	211	0
+211	211.5	212	0
+212	212.5	213	0
+213	213.5	214	0
+214	214.5	215	0
+215	215.5	216	0
+216	216.5	217	0
+217	217.5	218	0
+218	218.5	219	0
+219	219.5	220	0
+220	220.5	221	0
+221	221.5	222	0
+222	222.5	223	0
+223	223.5	224	0
+224	224.5	225	0
+225	225.5	226	0
+226	226.5	227	0
+227	227.5	228	0
+228	228.5	229	0
+229	229.5	230	0
+230	230.5	231	0
+231	231.5	232	0
+232	232.5	233	0
+233	233.5	234	0
+234	234.5	235	0
+235	235.5	236	0
+236	236.5	237	0
+237	237.5	238	0
+238	238.5	239	0
+239	239.5	240	0
+240	240.5	241	0
+241	241.5	242	0
+242	242.5	243	0
+243	243.5	244	0
+244	244.5	245	0
+245	245.5	246	0
+246	246.5	247	0
+247	247.5	248	0
+248	248.5	249	0
+249	249.5	250	0
+250	250.5	251	0
+251	251.5	252	0
+252	252.5	253	0
+253	253.5	254	0
+254	254.5	255	0
+255	255.5	256	0
+256	256.5	257	0
+257	257.5	258	0
+258	258.5	259	0
+259	259.5	260	0
+260	260.5	261	0
+261	261.5	262	0
+262	262.5	263	0
+263	263.5	264	0
+264	264.5	265	0
+265	265.5	266	0
+266	266.5	267	0
+267	267.5	268	0
+268	268.5	269	0
+269	269.5	270	0
+270	270.5	271	0
+271	271.5	272	0
+272	272.5	273	0
+273	273.5	274	0
+274	274.5	275	0
+275	275.5	276	0
+276	276.5	277	0
+277	277.5	278	0
+278	278.5	279	0
+279	279.5	280	0
+280	280.5	281	0
+281	281.5	282	0
+282	282.5	283	0
+283	283.5	284	0
+284	284.5	285	0
+285	285.5	286	0
+286	286.5	287	0
+287	287.5	288	0
+288	288.5	289	0
+289	289.5	290	0
+290	290.5	291	0
+291	291.5	292	0
+292	292.5	293	0
+293	293.5	294	0
+294	294.5	295	0
+295	295.5	296	0
+296	296.5	297	0
+297	297.5	298	0
+298	298.5	299	0
+299	299.5	300	0
+300	300.5	301	0
+301	301.5	302	0
+302	302.5	303	0
+303	303.5	304	0
+304	304.5	305	0
+305	305.5	306	0
+306	306.5	307	0
+307	307.5	308	0
+308	308.5	309	0
+309	309.5	310	0
+310	310.5	311	0
+311	311.5	312	0
+312	312.5	313	0
+313	313.5	314	0
+314	314.5	315	0
+315	315.5	316	0
+316	316.5	317	0
+317	317.5	318	0
+318	318.5	319	0
+319	319.5	320	0
+320	320.5	321	0
+321	321.5	322	0
+322	322.5	323	0
+323	323.5	324	0
+324	324.5	325	0
+325	325.5	326	0
+326	326.5	327	0
+327	327.5	328	0
+328	328.5	329	0
+329	329.5	330	0
+330	330.5	331	0
+331	331.5	332	0
+332	332.5	333	0
+333	333.5	334	0
+334	334.5	335	0
+335	335.5	336	0
+336	336.5	337	0
+337	337.5	338	0
+338	338.5	339	0
+339	339.5	340	0
+340	340.5	341	0
+341	341.5	342	0
+342	342.5	343	0
+343	343.5	344	0
+344	344.5	345	0
+345	345.5	346	0
+346	346.5	347	0
+347	347.5	348	0
+348	348.5	349	0
+349	349.5	350	0
+350	350.5	351	0
+351	351.5	352	0
+352	352.5	353	0
+353	353.5	354	0
+354	354.5	355	0
+355	355.5	356	0
+356	356.5	357	0
+357	357.5	358	0
+358	358.5	359	0
+359	0	0	0